Index: /branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure.UI/HeuristicLab.PluginInfrastructure.UI-4.0.csproj
===================================================================
--- /branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure.UI/HeuristicLab.PluginInfrastructure.UI-4.0.csproj	(revision 13339)
+++ /branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure.UI/HeuristicLab.PluginInfrastructure.UI-4.0.csproj	(revision 13340)
@@ -131,4 +131,5 @@
       <Project>{94186a6a-5176-4402-ae83-886557b53cca}</Project>
       <Name>HeuristicLab.PluginInfrastructure-3.3</Name>
+      <Private>False</Private>
     </ProjectReference>
   </ItemGroup>
@@ -138,6 +139,15 @@
   <ItemGroup>
     <None Include="HeuristicLab.snk" />
+    <None Include="Properties\AssemblyInfo.cs.frame" />
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd</PreBuildEvent>
+  </PropertyGroup>
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
        Other similar extension points exist, see Microsoft.Common.targets.
Index: anches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure.UI/Properties/AssemblyInfo.cs
===================================================================
--- /branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure.UI/Properties/AssemblyInfo.cs	(revision 13339)
+++ 	(revision )
@@ -1,36 +1,0 @@
-﻿using System.Reflection;
-using System.Runtime.CompilerServices;
-using System.Runtime.InteropServices;
-
-// General Information about an assembly is controlled through the following 
-// set of attributes. Change these attribute values to modify the information
-// associated with an assembly.
-[assembly: AssemblyTitle("HeuristicLab.PluginInfrastructure.UI")]
-[assembly: AssemblyDescription("")]
-[assembly: AssemblyConfiguration("")]
-[assembly: AssemblyCompany("FH-Hagenberg")]
-[assembly: AssemblyProduct("HeuristicLab.PluginInfrastructure.UI")]
-[assembly: AssemblyCopyright("Copyright © FH-Hagenberg 2015")]
-[assembly: AssemblyTrademark("")]
-[assembly: AssemblyCulture("")]
-
-// Setting ComVisible to false makes the types in this assembly not visible 
-// to COM components.  If you need to access a type in this assembly from 
-// COM, set the ComVisible attribute to true on that type.
-[assembly: ComVisible(false)]
-
-// The following GUID is for the ID of the typelib if this project is exposed to COM
-[assembly: Guid("27f6bebc-0602-4e1e-ab12-02b3d49caa6e")]
-
-// Version information for an assembly consists of the following four values:
-//
-//      Major Version
-//      Minor Version 
-//      Build Number
-//      Revision
-//
-// You can specify all the values or you can default the Build and Revision Numbers 
-// by using the '*' as shown below:
-// [assembly: AssemblyVersion("1.0.*")]
-[assembly: AssemblyVersion("1.0.0.0")]
-[assembly: AssemblyFileVersion("1.0.0.0")]
Index: /branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure.UI/Properties/AssemblyInfo.cs.frame
===================================================================
--- /branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure.UI/Properties/AssemblyInfo.cs.frame	(revision 13340)
+++ /branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure.UI/Properties/AssemblyInfo.cs.frame	(revision 13340)
@@ -0,0 +1,57 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+using System.Security;
+using System;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.PluginInfrastructure.UI")]
+[assembly: AssemblyDescription("PluginInfrastructure UI components for HeuristicLab plugins")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2015 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+[assembly: CLSCompliant(true)]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("CA06F8A2-CE30-4532-811B-E34786451E24")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+[assembly: AssemblyVersion("4.0.0.0")]
+[assembly: AssemblyFileVersion("4.0.0.$WCREV$")]
Index: /branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure.UI/SplashScreen.Designer.cs
===================================================================
--- /branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure.UI/SplashScreen.Designer.cs	(revision 13339)
+++ /branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure.UI/SplashScreen.Designer.cs	(revision 13340)
@@ -58,7 +58,7 @@
       this.versionLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
       this.versionLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 6F);
-      this.versionLabel.Location = new System.Drawing.Point(436, 147);
+      this.versionLabel.Location = new System.Drawing.Point(320, 147);
       this.versionLabel.Name = "versionLabel";
-      this.versionLabel.Size = new System.Drawing.Size(150, 9);
+      this.versionLabel.Size = new System.Drawing.Size(266, 10);
       this.versionLabel.TabIndex = 1;
       this.versionLabel.Text = "Version ";
@@ -67,6 +67,6 @@
       // infoLabel
       // 
-      this.infoLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.infoLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.infoLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
       this.infoLabel.ForeColor = System.Drawing.Color.DarkOrange;
@@ -91,7 +91,7 @@
       // pictureBox
       // 
-      this.pictureBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.pictureBox.Image = Resources.HeuristicLabBanner;
+      this.pictureBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.pictureBox.Image = global::HeuristicLab.PluginInfrastructure.UI.Resources.HeuristicLabBanner;
       this.pictureBox.Location = new System.Drawing.Point(0, 0);
       this.pictureBox.Name = "pictureBox";
@@ -103,5 +103,4 @@
       // SplashScreen
       // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
       this.BackColor = System.Drawing.Color.White;
@@ -113,5 +112,5 @@
       this.Controls.Add(this.infoLabel);
       this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
-      this.Icon = Resources.HeuristicLab;
+      this.Icon = global::HeuristicLab.PluginInfrastructure.UI.Resources.HeuristicLab;
       this.MaximizeBox = false;
       this.MinimizeBox = false;
Index: /branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure.UI/SplashScreen.cs
===================================================================
--- /branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure.UI/SplashScreen.cs	(revision 13339)
+++ /branches/RefactorPluginInfrastructure-2522/HeuristicLab.PluginInfrastructure.UI/SplashScreen.cs	(revision 13340)
@@ -44,8 +44,8 @@
       RegisterPluginManagerEventHandlers();
 
-      versionLabel.Text = "Version " + AssemblyExtensions.GetFileVersion(GetType().Assembly);
+      versionLabel.Text = "Version " + typeof(PluginManager).Assembly.GetFileVersion() + " Windischgarsten (11/2015)";
       infoLabel.Text = "";
 
-      var attr = (AssemblyCopyrightAttribute)this.GetType().Assembly.GetCustomAttributes(typeof(AssemblyCopyrightAttribute), false).Single();
+      var attr = (AssemblyCopyrightAttribute)typeof(PluginManager).Assembly.GetCustomAttributes(typeof(AssemblyCopyrightAttribute), false).Single();
       copyrightLabel.Text = "Copyright " + attr.Copyright;
 
Index: /branches/RefactorPluginInfrastructure-2522/HeuristicLab/3.3/HeuristicLab-3.3.csproj
===================================================================
--- /branches/RefactorPluginInfrastructure-2522/HeuristicLab/3.3/HeuristicLab-3.3.csproj	(revision 13339)
+++ /branches/RefactorPluginInfrastructure-2522/HeuristicLab/3.3/HeuristicLab-3.3.csproj	(revision 13340)
@@ -191,4 +191,5 @@
       <Project>{7af3c7b6-8ba5-44f3-8d5b-2bf7a23cf12d}</Project>
       <Name>HeuristicLab.PluginInfrastructure.UI-4.0</Name>
+      <Private>False</Private>
     </ProjectReference>
   </ItemGroup>